<!DOCTYPE html>
<html>
<head>
    <title>Curso Java</title>
</head>

<body>
    <h1> Fundamentos de Java Script </h1>
    <script>
        /*
        //La Sentencia var sirve para declarar varibles globales
        var hola = "hola mundo";
        //La Sentencia let sirve para declarar varibles en bloques
        let hello = "Hello World";
        //resumen Utilizar let debido a que es para solo bloques y es mas ordenada
        console.log(hola);
        console.log(hello);
        console.log(window);
        console.log(window.hola);
        console.log(window.hello);
        //Ambito de bloque
        var musica = "Rock";
        console.log("***********************Con Var abajo***************************")
        console.log("Variable Musica antes del Bloque", musica);
        //Este es un Bloque
        {
            var musica = "Pop";
            console.log("Variable Musica dentro del Bloque", musica);
        }
        console.log("Varible Musica Despues del bloque", musica)
        console.log("***********************Con Let abajo***************************")
        //con Let
        let musica2 = "Rock";
        console.log("Variable Musica antes del Bloque", musica2);
        //Este es un Bloque
        {
            let musica2 = "Pop";
            console.log("Variable Musica dentro del Bloque", musica2);
        }
        console.log("Varible Musica Despues del bloque", musica2)
        */

        /* La sentencia const nos sirve para dar valores fijos
        let a;  las varibles tanto como let y var
                se pueden utilizar sin valores fijos.
        */
       /*
        a = "kenai";
        const PI = 3.1416;
        console.log(PI);
        console.log(a);
        //conjunto de Atributos y llaves con su respectivo valor
        const objeto = {
            nombre: "David",
            edad: 35
        };

        //un arreglo es una colección de datos
        const colores = [
            "blanco", "negro", "azul"    
        ];
        console.log(objeto);
        console.log(colores);

        objeto.correo = "davidcastroastudillo10@gmail.com";
        objeto.nombre = "Pablo";
        objeto.edad = 17;
        objeto.correo = "pablitogamer@gmail.com";
        colores.push("Naranja");

        console.log(objeto);
        console.log(colores);

        //Cadena de Texto o Strings
        let nombre = "David";
        let apellido = "Castro";
        let saludo = new String("Hola Mundo");
        let text = "                Este es un Texto que se repite repite"

        console.log(nombre, apellido, saludo);
        console.log(nombre.length,
                    apellido.length,
                    saludo.length,
                    nombre.toLowerCase(),
                    apellido.toUpperCase(),
                    text.includes("repite"),
                    text.includes("David"),
                    text,
                    text.trim(),
                    text.split(" "));
        */

       //Concatenación
       /*
        let nombre = "David";
        let apellido = "Castro";

        let saludo = "Hola Mi Nombre es "
        + nombre + " " + apellido + "."
        console.log(saludo);
        //Interpolación de varibles
        //Template String
        let saludo2 = `Hola mi nombre es ${nombre} ${apellido}.`;
        console.log(saludo2);

        let ul = "<ul><li>Primavera</li><li>Verano</li><li>Otoño</li><li>Invierno</li></ul> ";

        console.log(ul)

        let ul2 =`    <ul>
        <li>Primavera</li>
        <li>Verano</li>
        <li>Otoño</li>
        <li>Invierno</li>
    </ul>`;

    console.log(ul2)
    */

    /*
    //Numeros

    let a = 2;
    let b = new Number(1);
    let c = 7.19;
    let d = "5.6";

    console.log(a, b);
    console.log(c.toFixed(1));
    console.log(c.toFixed(5));
    console.log(parseInt(c));
    console.log(parseFloat(c))
    console.log(typeof c, typeof d)
    console.log(a + b);
    console.log(c + parseInt(d));
    console.log(c + parseFloat(d));
    */

    //Datos booleanos
    /*
    let verdadero = true;
    let falso = false;

    console.log(verdadero, falso);
    console.log(typeof verdadero,typeof falso);

    let v = Boolean(true);
    let f = Boolean(false);
    console.log(Boolean(0));
    console.log(Boolean(-7))
    console.log(Boolean(""))
    console.log(Boolean(" "))
    */

    /*
    let indefinida;
    console.log(indefinida);

    let nulo = null;
    console.log(nulo);

    let noEsUnNumero = "hola" * 32
    console.log(noEsUnNumero)
    */
   //Función declarada
   /*function estoEsUnaFuncion(){
    console.log("Uno")
    console.log("Dos")
    console.log("Tres")
   }
   */
  /*
   function unaFuncionQueDevuelveValores(a, b, c){
    return a + b + c
   }
   a = 8
   b = 15
   c = 19

   let valorDeFuncion = unaFuncionQueDevuelveValores(a, b, c)

   function saludar(nombre, edad){
    console.log(`Hola es un gusto Conocerte ${nombre} y Tengo ${edad}`);
   }

   saludar("Kenai", valorDeFuncion);

   //Funciones declaradas VS Funciones Expresadas
   function funcionDeclarada(){
    console.log("Esto es una Función declarada, puede invorcarse donde sea");
   }
   funcionDeclarada()

   //función anónima
   const funcionExpresada = function(){
    console.log("Esto es una Funcion expresada.")
   }

   funcionExpresada()
   */
   /*
   const a = []
   const b = [1, true, "Hola", ["A", "B", "C"]]
   console.log(a);
   console.log(b);
   console.log(b.length);
   console.log(b[3][2])
   
   const c = Array.of("X", "Y", "Z", 9, 8, 7)
   console.log(c)

   const d = Array(100).fill(false)
   console.log(d)

   const e = new Array();
   console.log(e)

   const f = new Array(1, 2, 3, false, true)
   console.log(f)

   const colores = ["Rojo", "Verde", "Azul"]
   console.log(colores)

   colores.push("Negro")
   console.log(colores)

   colores.pop();
   console.log(colores)

   colores.forEach(function (el, i) {
    console.log(`<li id ="${i}">${el}</li>`)
   });
   */
   /*
    dentro de un objeto a las varible se les llama
    Atributos/Propiedades y a las funciones se les llama métodos
   */
  /*
   let a = new String("Hola")
   //console.log(a)

   const b = {}
   console.log(b)

   const david = {
    nombre: "David",
    apellido: "castro",
    edad: 35,
    pasatiempos: ["Correr", "Hacer ejercicio",
    "dormir"],
    soltero: true,
    contacto: {
        email: "davidcastroastudillo10@gmail.com",
        movil: null
    },
    saludar: function () {
        console.log(`Hola :)`)
    },
    decirMiNombre: function () {
        console.log(`Hola ${this.nombre} ${this.apellido}, ¿como te encunetras el día de hoy?.`)
    }
}

   console.log(david);
   console.log(david["nombre"]);
   console.log(david["apellido"]);
   console.log(david.nombre);
   console.log(david.apellido);
   console.log(david.edad);
   console.log(david.soltero);
   console.log(david.pasatiempos);
   console.log(david.pasatiempos[2])
   console.log(david.contacto.email)
   david.saludar();
   david.decirMiNombre();

   console.log(Object.keys(david))
   console.log(Object.values(david))
   console.log(david.hasOwnProperty("nombre"))
   console.log(david.hasOwnProperty("david"))
   */


    /* Operadores */
    /* Aritmeticos + - * / % () */
    /*
    let a = 5 + 5 - 10 * 3;
    let modulo = 5 % 2

    console.log(a)
    console.log(modulo)
    */
/*    Relacionales: >, <, >=, <=, ==, ===, !=, !== */
    /*
    console.log( 8 > 9 );
    console.log( 8 < 9 );
    console.log( 8 >= 9 );
    console.log( 8 <= 9 );
    */
    /*
    = 1 igual es a asignación de varible
    == 2 iguales es comparación de valores
    === 3 iguales
    */

    /*
    console.log(7 == 7);
    console.log("7" == 7);
    console.log(0 == false);

    console.log(7 === 7);
    console.log("7" === 7);
    console.log(0 === false);
    */
    //Incremento Decremento
    /*let i = 2;
    console.log(i++);
    console.log(i)
    console.log(++i)
    console.log(i)
    console.log(--i)
    console.log(i)
    console.log(i--)
    console.log(i)
    */
    /*
    i += 2;
    console.log(i);
    */
    /*i++;
    i--;
    ++i;
    --i;
    console.log(i)*/
    /*
    ! - Not = Niega, lo que es verdadero, se vuelve false, o al revez
    || - Or = cuando tengo 2 o mas condiciones, co que 1
              se cumpla (sea verdadera), el Or validara
    && - And = cuando tengo de 2 o mas condiciones todas tiene que
               cumplirse, todas tiene que ser verdaderas.
    */
    /*
    console.log(!true)
    console.log(!false)
    console.log((9 === 9) || ("9" === 9))
    console.log((9 === 9) && ("9" === 9))
    console.log((9 === 9) && ("9" === "9"))
    */

    /* if - else */
    /*
    let edad = 18;
    */
    /*
    if (edad = 17) {
        console.log("Eres mayor de edad")
    } else {
        console.log("Eres menor de edad")
    }


    if (edad >= 18) {
        console.log("Eres mayor de edad")
    } else {
        console.log("Eres menor de edad")
    }

    if (edad < 18) {
        console.log("Eres mayor de edad")
    } else {
        console.log("Eres menor de edad")
    }

    if (edad <= 17) {
        console.log("Eres mayor de edad")
    } else {
        console.log("Eres menor de edad")
    }
    */
    /* if - else if - else */
    /*
    Dejame Dormir - 0hrs - 5hrs
    Buenos dias 6hrs - 11hrs
    Buenas Tardes 12hrs - 18hrs
    Buenas Noches 19hrs - 23hrs
    */
    /*
    let horas = 19;
    */
    /*
    if (horas >= 0 && horas <= 5) {
        console.log("dejame dormir")
    } else if (horas >= 6 && horas <= 11) {
        console.log("Buenos Dias")
    } else if (horas >= 12 && horas <= 18){
        console.log("Buenas Tardes")
    } else {
        console.log("Buenas Noches")
    }
    */
    /* Operador Ternario (Condción) ? verdad : falsa */
    /*
    console.log("Operador Ternario")
    let eresMayor = (edad >= 18)
    ? "Eres mayor de edad"
    : "Eres menor de edad";

    console.log(eresMayor);
    */
    /* switch - case */
    /*
    Domingo = 0
    Lunes = 1
    Martes = 2
    Miercoles = 3
    Jueves = 4
    Viernes = 5
    Sabado = 6
    */
    /*
   let dia = 4;

    switch (dia) {
        case 0:
            console.log("Domingo");
            break;
        case 1:
            console.log("Lunes");
            break;
        case 2:
            console.log("Martes");
            break;
        case 3:
            console.log("Miercoles");
            break;
        case 4:
            console.log("Jueves");
            break;
        case 5:
            console.log("Viernes");
            break;
        case 6:
            console.log("Sabado");
            break;
        default:
            console.log("El Dia No Existe");
            break;
    }
    */
    /*
    let contador = 0;
    */
    /*
    while ( contador < 10 ){
        console.log("While " + contador);
        contador++;
    }
    */
   /*
    do {
        console.log("do While " + contador);
        contador++;
    } while( contador < 10 );
    */

    /* experimiento
    for (let i = 0; i < 10; i++) {
        console.log("for " + i);
    }
    */ 
    /*
    let numeros = [10, 20, 30, 40, 50, 60, 70, 80, 90];

    /*
    for (let i = 0; i < numeros.length; i++){
            console.log(numeros[i])
    }
    */

    /*
    const david = {
        nombre: "David",
        apellido: "Castro",
        edad: 17
    }

    for (const i in david) {
        console.log(`Key: ${i}, value: ${david[i]}`);
    }

    for (const x of numeros) {
        console.log(x)
    }

    let cadena = "Hola Mundo";

    for (const c of cadena) {
        console.log(c)
    }
    */
    /*
    try {
        console.log("En El Try se agrega el codigo a evaluar");
        noExiste;
        console.log("segundo Mensaje en el Try");
    } catch (error) {
        console.log("Catch, captura cualquier error surgido o lanzado en el try");
        console.log(error);
    } finally{
        console.log("El Bloque Finally siempre al final de todo.");
    }
    */
    /*
    try {
        let numero = "y";

        if (isNaN(numero)){
            throw new Error("El Caractér introducido no es un Número");
        }

        console.log(numero * numero);
    } catch (error) {
        console.log(`Se pordujo el Siguiente Error: ${error}`);
    }
    */

   /*
   const david = ["papallas", "Manzanas", "Cebollas", "Culantro"]


   for (let i of david) {
    if (david[i] = "Manzanas"){
        console.log(david[i])
        break;
    }
   }
   */

   /*
   //Imprima la suma de todos los numero del 1 al 100
   let x = 0
   for (let  i = 0;  i < 100; i++) {
    x += 1
   }
    console.log(x)
    */

   //Suma de Todos Los números Impares
   /*
   let sum = 0;
   for (let i = 0;  i < 100; i++) {
    if (i % 2 != 0){
        sum += i
    }
   }
   console.log(sum)
   */

   //conocer el Usuario Registrado y Mostrar solo sus datos por su id.

   /* Esta es una Forma en la que Aprendi a como Sacar un Usuario Por su ID
   const Users = {
    id: 1,
    Nombre: "David",
    correo: "davidcastroastudillo10@gmail.com",
    edad: 17,
    id: 2,
    Nombre: "Jose",
    correo: "pablito@gmail.com",
    edad: 25
   }


   for (const i in Users) {
    if (i.id === 2){
        console.log(Users[i])
        break;
    }
    }
    */
    /*
    const numeros = [1, 2, 3, 4, 5, 6, 7, 8, 9, 0]

    for (let i = 0; i < numeros.length; i++) {
        if (i === 5){
            continue;
        }
    console.log(numeros[i]);
    }
    */
    /*
    //Estructuración
    //Sin Estructuración
    numero = [1, 2, 3]

    let uno = numero[0]
        dos = numero[1]
        tres = numero[2]
    console.log(uno, dos, tres)

    //con estructuración
    let [one, two, three] = numero;
    console.log(one, two, three)

    const persona = {
        nombre: "David",
        apellido: "castro",
        edad: 17
    }

    let {nombre, apellido, edad} = persona
    console.log(nombre, apellido, edad)
    */
    /*
    let nombre = "gato"
        edad = 5
    
    const perro = {
        nombre: nombre,
        edad: edad,
        ladrar: function () {
            console.log("Guau Guau")
        }
    }

    console.log(perro)
    perro.ladrar()

    const dog = {
        nombre,
        edad,
        ladrar(){
            console.log("Guau Guau Miau")
        }
    }

    console.log(dog)
    dog.ladrar()
    */
   /*
    function sumar(a, b, ...c){
        let resultado = a + b
    
        c.forEach(function(n){
            resultado += n
        });
        return resultado;
    };

    console.log(sumar(1, 2))
    console.log(sumar(1, 2, 6))
    console.log(sumar(1, 2, 5, 7, 2, 4))
    console.log(sumar(1, 2, 62 ,5 , 2, 6))
    console.log(sumar(1,2, 7, 5, 5, 6, 3, 21))


    const arr1 = [1, 2, 3, 4, 5],
          arr2 = [6, 7, 8, 9, 0]

    console.log(arr2, arr2)

    const arr3 = [...arr1, ...arr2];
    console.log(arr3)
    */

    /*
    function agregar(nombre, apellido, ...e){
        datos = {
            nombre,
            apellido,
        }

        let a;

        e.forEach(function (e) {
            Object.defineProperty(datos, "extras",{value: e})
        })

        console.log(datos)
        for (const i in datos) {
            if (i == "nombre"){
                a = "nombre: "
                console.log(`key: ${i}, ${a} ${datos[i]}`)
            } else if (i == "apellido") {
                a = "Apellido: "
                console.log(`key: ${i}, ${a} ${datos[i]}`)
            } else if (i == "extras"){
                a = "Extras"
                console.log("Hola")
            }
        }
    }

    agregar("David", "Castro", "Pablo")
    */

    /* Arrow Function */
    
    /*
    const saludar = nombre => console.log(`Hola ${nombre}`)
    saludar("David")

    const sumar = (a, b) => a + b

    console.log(sumar(9, 9))

    const funcionDeVariasLineas = () => {
        console.log("Uno");
        console.log("Dos");
        console.log("Tres");
    }

    funcionDeVariasLineas();

    const numeros = [1, 2, 3, 4, 5];

    numeros.forEach((el, i) => console.log(`${el}, esta en la posición ${i}`));

    
    function Perro () {console.log(this)}
    
    Perro();
    */
   
    /*
    const perro = {
        nombre: "Lua",
        ladrar: function() {
            console.log(this)
        }
    }

    perro.ladrar()
    */

    const log = console.log;

    //POO
    /*
    Clases - Modelo a seguir
    Objetos - Es una Instancia de una clase
      -Atributos - Es una Caracteristicas o Propiedad Objeto (Son Varibles dentro de un Objeto)
      -Metodos - son las acciones que un objeto puede realizar  (Son Funciones dentro de un Metodo)
    */
    /*
    const animal = {
        nombre: "Lua",
        sonar(){
            log("Hago un ruido, porque estoy vivo.");
        }
    }

    log(animal)

    const animal2 = {
        nombre: "Lola bunny",
        sonar(){
            log("Hago un ruido, porque estoy vivo.");
        }
    }

    log(animal2)
    */

    //Función constructora
    /*
    function Animal (nombre, genero) {
        //Atributos
        this.nombre = nombre;
        this.genero = genero;
        //Metodos
        this.sonar = function () {
            log("Hago sonidos porque estoy vivo");
        }
        this.saludar = function () {
            log(`Hola Me llamo ${this.nombre}`)
        }
    }
    */

    
    function Animal (nombre, genero) {
        //Atributos
        this.nombre = nombre;
        this.genero = genero;
    }

    //Metodos
    Animal.prototype.sonar = function () {
        log("Hago sonidos porque estoy vivo");
        }
    Animal.prototype.saludar = function () {
        log(`Hola Me llamo ${this.nombre}`)
        }


    /*
    const Lua = new Animal("Lua", "Hembra"),
    LolaBunny = new Animal("Lola Bunny", "Hembra");

    log(Lua);
    log(LolaBunny);

    Lua.sonar()
    Lua.saludar()

    LolaBunny.sonar()
    LolaBunny.saludar()
    */

    /* Examen */
    /*
    -Hacer un programa que ingrese nuevos usuarios los cuales tienen 
    -Que Registrar a Nuevos Usuarios y Tendran que tener una id
    -Para Poder Localizarlos.  
    */


    // Herencia prototipica

    function Perro(nombre, genero, tamanio){
        this.super = Animal;
        this.super(nombre, genero)
        this.tamanio = tamanio
    }

    // Perro esta heredando de Animal
    Perro.prototype = new Animal();
    Perro.prototype.constructor = Perro;

    // Sobreescritura de metodos del prototipo Padre en el hijo
    Perro.prototype.sonar = function (){
        log("soy un perro y este es un ladrido");
    }

    Perro.prototype.ladrar = function(){
        log("Ladra como un perro")
    }

    const Lua = new Perro("Lua", "Hembra", "Mediano"),
     LoLaBunny = new Animal("Lola Bunny", "Hembra")
    

    console.log(Lua)
    console.log(LoLaBunny)

    Lua.sonar()
    Lua.saludar()

    LoLaBunny.sonar()
    LoLaBunny.saludar()















    </script>
</body>

</html>